diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/Player.java
similarity index 75%
rename from src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
rename to src/main/java/net/minecraft/core/entity/player/Player.java
index c689d17d5..9f0485ba7 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -956,24 +999,24 @@ public abstract class EntityPlayer extends EntityLiving
             }
             entity.hurt(this, i, DamageType.COMBAT);
             ItemStack itemstack = getCurrentEquippedItem();
-            if(itemstack != null && (entity instanceof EntityLiving))
+            if(itemstack != null && (entity instanceof Mob))
             {
-                itemstack.hitEntity((EntityLiving)entity, this);
+                itemstack.hitEntity((Mob)entity, this);
                 if(itemstack.stackSize <= 0)
                 {
                     destroyCurrentEquippedItem();
                 }
             }
-            if(entity instanceof EntityLiving)
+            if(entity instanceof Mob)
             {
                 if(entity.isAlive())
                 {
-                    alertWolves((EntityLiving)entity, true);
+                    alertWolves((Mob)entity, true);
                 }
                 addStat(StatList.damageDealtStat, i);
             }
         }
-        String entityName = EntityDispatcher.getEntityString(entity);
+        String entityName = EntityDispatcher.getEncodeId(entity);
         addStat(StatList.mobEncounterStats.get(entityName), 1);
     }
 
@@ -1028,7 +1071,7 @@ public abstract class EntityPlayer extends EntityLiving
                 return EnumSleepStatus.DISABLED_BY_GAMERULE;
             }
 
-            if(world.isDaytime() && world.getCurrentWeather() != Weather.overworldStorm) {
+            if(world.isDaytime() && world.getCurrentWeather() != Weathers.OVERWORLD_STORM) {
             	sendStatusMessage(I18n.getInstance().translateKey("bed.noSleep"));
                 return EnumSleepStatus.NOT_POSSIBLE_NOW;
             }
@@ -1043,7 +1086,7 @@ public abstract class EntityPlayer extends EntityLiving
         if(world.isBlockLoaded(x, y, z))
         {
             int meta = world.getBlockMetadata(x, y, z);
-            int dir = BlockBed.getDirectionFromMetadata(meta);
+            int dir = BedBlock.getDirection(meta);
             float xOff = 0.5F;
             float zOff = 0.5F;
             
@@ -1074,24 +1117,24 @@ public abstract class EntityPlayer extends EntityLiving
 
     private void func_22052_e(int i)
     {
-        field_22063_x = 0.0F;
-        field_22061_z = 0.0F;
+        sleepOffX = 0.0F;
+        sleepOffZ = 0.0F;
         switch(i)
         {
         case 0: // '\0'
-            field_22061_z = -1.8F;
+            sleepOffZ = -1.8F;
             break;
 
         case 2: // '\002'
-            field_22061_z = 1.8F;
+            sleepOffZ = 1.8F;
             break;
 
         case 1: // '\001'
-            field_22063_x = 1.8F;
+            sleepOffX = 1.8F;
             break;
 
         case 3: // '\003'
-            field_22063_x = -1.8F;
+            sleepOffX = -1.8F;
             break;
         }
     }
@@ -1101,10 +1144,10 @@ public abstract class EntityPlayer extends EntityLiving
         setSize(0.6F, 1.8F);
         resetHeight();
         ChunkCoordinates chunkcoordinates = bedChunkCoordinates;
-        if(chunkcoordinates != null && world.getBlock(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z) instanceof BlockBed)
+        if(chunkcoordinates != null && world.getBlock(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z) instanceof BedBlock)
         {
-            BlockBed.setBedOccupied(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, false);
-            ChunkCoordinates chunkcoordinates2 = BlockBed.getNearestEmptyChunkCoordinates(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, 0);
+            BedBlock.setBedOccupied(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, false);
+            ChunkCoordinates chunkcoordinates2 = BedBlock.getNearestEmptyChunkCoordinates(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, 0);
             if(chunkcoordinates2 == null)
             {
                 chunkcoordinates2 = new ChunkCoordinates(chunkcoordinates.x, chunkcoordinates.y + 1, chunkcoordinates.z);
@@ -1127,7 +1170,7 @@ public abstract class EntityPlayer extends EntityLiving
 
     private boolean isInBed()
     {
-        return world.getBlock(bedChunkCoordinates.x, bedChunkCoordinates.y, bedChunkCoordinates.z) instanceof BlockBed;
+        return world.getBlock(bedChunkCoordinates.x, bedChunkCoordinates.y, bedChunkCoordinates.z) instanceof BedBlock;
     }
 
     public static ChunkCoordinates getValidBedSpawnCoordinates(World world, ChunkCoordinates coords)
@@ -1138,8 +1181,8 @@ public abstract class EntityPlayer extends EntityLiving
         chunkProvider.prepareChunk(coords.x + 3 >> 4, coords.z - 3 >> 4);
         chunkProvider.prepareChunk(coords.x - 3 >> 4, coords.z + 3 >> 4);
         chunkProvider.prepareChunk(coords.x + 3 >> 4, coords.z + 3 >> 4);
-        if (world.getBlock(coords.x, coords.y, coords.z) instanceof BlockBed) {
-            return BlockBed.getNearestEmptyChunkCoordinates(world, coords.x, coords.y, coords.z, 0);
+        if (world.getBlock(coords.x, coords.y, coords.z) instanceof BedBlock) {
+            return BedBlock.getNearestEmptyChunkCoordinates(world, coords.x, coords.y, coords.z, 0);
         } else {
             return null;
         }
@@ -1150,7 +1193,7 @@ public abstract class EntityPlayer extends EntityLiving
         if(bedChunkCoordinates != null)
         {
             int i = world.getBlockMetadata(bedChunkCoordinates.x, bedChunkCoordinates.y, bedChunkCoordinates.z);
-            int j = BlockBed.getDirectionFromMetadata(i);
+            int j = BedBlock.getDirection(i);
             switch(j)
             {
             case 0: // '\0'
@@ -1267,7 +1310,7 @@ public abstract class EntityPlayer extends EntityLiving
         }
         if(isUnderLiquid(Material.water))
         {
-            int i = java.lang.Math.round(MathHelper.sqrt_double(d * d + d1 * d1 + d2 * d2) * 100F);
+            int i = java.lang.Math.round(MathHelper.sqrt(d * d + d1 * d1 + d2 * d2) * 100F);
             if(i > 0)
             {
                 addStat(StatList.distanceDoveStat, i);
@@ -1275,7 +1318,7 @@ public abstract class EntityPlayer extends EntityLiving
         } else
         if(isInWater())
         {
-            int j = java.lang.Math.round(MathHelper.sqrt_double(d * d + d2 * d2) * 100F);
+            int j = java.lang.Math.round(MathHelper.sqrt(d * d + d2 * d2) * 100F);
             if(j > 0)
             {
                 addStat(StatList.distanceSwumStat, j);
@@ -1290,14 +1333,14 @@ public abstract class EntityPlayer extends EntityLiving
         } else
         if(onGround)
         {
-            int k = java.lang.Math.round(MathHelper.sqrt_double(d * d + d2 * d2) * 100F);
+            int k = java.lang.Math.round(MathHelper.sqrt(d * d + d2 * d2) * 100F);
             if(k > 0)
             {
                 addStat(StatList.distanceWalkedStat, k);
             }
         } else
         {
-            int l = java.lang.Math.round(MathHelper.sqrt_double(d * d + d2 * d2) * 100F);
+            int l = java.lang.Math.round(MathHelper.sqrt(d * d + d2 * d2) * 100F);
             if(l > 25)
             {
                 addStat(StatList.distanceFlownStat, l);
@@ -1309,26 +1352,26 @@ public abstract class EntityPlayer extends EntityLiving
     {
         if(vehicle != null)
         {
-            int i = java.lang.Math.round(MathHelper.sqrt_double(d * d + d1 * d1 + d2 * d2) * 100F);
+            int i = java.lang.Math.round(MathHelper.sqrt(d * d + d1 * d1 + d2 * d2) * 100F);
             if(i > 0)
             {
-                if(vehicle instanceof EntityMinecart)
+                if(vehicle instanceof MinecartEntity)
                 {
                     addStat(StatList.distanceByMinecartStat, i);
                     if(startMinecartRidingCoordinate == null)
                     {
-                        startMinecartRidingCoordinate = new ChunkCoordinates(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z));
+                        startMinecartRidingCoordinate = new ChunkCoordinates(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
                     } else
-                    if(startMinecartRidingCoordinate.getSqDistanceTo(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) >= 1000D)
+                    if(startMinecartRidingCoordinate.getSqDistanceTo(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) >= 1000D)
                     {
-                        addStat(AchievementList.ON_A_RAIL, 1);
+                        addStat(Achievements.ON_A_RAIL, 1);
                     }
                 } else
-                if(vehicle instanceof EntityBoat)
+                if(vehicle instanceof BoatEntity)
                 {
                     addStat(StatList.distanceByBoatStat, i);
                 } else
-                if(vehicle instanceof EntityPig)
+                if(vehicle instanceof PigMob)
                 {
                     addStat(StatList.distanceByPigStat, i);
                 }
@@ -1337,21 +1380,21 @@ public abstract class EntityPlayer extends EntityLiving
     }
 
     @Override
-	protected void causeFallDamage(float f)
+	protected void causeFallDamage(float distance)
     {
-        if(f >= 2.0F)
+        if(distance >= 2.0F)
         {
-            addStat(StatList.distanceFallenStat, (int) java.lang.Math.round((double)f * 100D));
+            addStat(StatList.distanceFallenStat, (int) java.lang.Math.round((double) distance * 100D));
         }
-        super.causeFallDamage(f);
+        super.causeFallDamage(distance);
     }
 
     @Override
-	public void killed(EntityLiving entityliving)
+	public void killed(Mob entityliving)
     {
-        if(entityliving instanceof EntityMonster)
+        if(entityliving instanceof Monster)
         {
-            triggerAchievement(AchievementList.KILL_ENEMY);
+            triggerAchievement(Achievements.KILL_ENEMY);
         }
     }
 
@@ -1385,7 +1428,7 @@ public abstract class EntityPlayer extends EntityLiving
     {
         this.gamemode = gamemode;
 
-        ContainerPlayer newContainer = gamemode.getContainer(this.inventory, !world.isClientSide);
+        InventoryMenu newContainer = gamemode.getContainer(this.inventory, !world.isClientSide);
         if (craftingInventory == inventorySlots)
         {
             craftingInventory = newContainer;
@@ -1430,8 +1473,8 @@ public abstract class EntityPlayer extends EntityLiving
     		return;
     	}
     	
-    	TileEntity tileEntity = world.getBlockTileEntity(x, y, z);
-    	ItemStack[] result = block.getBreakResult(world, EnumDropCause.PICK_BLOCK, x, y, z, meta, tileEntity);
+    	BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+    	ItemStack[] result = block.getBreakResult(world, EnumDropCause.PICK_BLOCK, x, y, z, meta, blockEntity);
     	ItemStack selectItem = result != null ? result[0] : null;
     	
     	if(selectItem == null) {
@@ -1440,7 +1483,7 @@ public abstract class EntityPlayer extends EntityLiving
     	
 		//Find item in hotbar, and select it
 		for(int i=0; i < 9; i++) {
-			ItemStack stack = inventory.getStackInSlot(i + inventory.hotbarOffset);
+			ItemStack stack = inventory.getItem(i + inventory.hotbarOffset);
 			if(stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata()) {
 				setCurrentItem(i + inventory.hotbarOffset);
 				return;
@@ -1451,7 +1494,7 @@ public abstract class EntityPlayer extends EntityLiving
 		int emptyHotbarSlot = -1;
 		int slot = inventory.currentItem;
 		for(int i=0; i < 9; i++) {
-			if(inventory.getStackInSlot(i + inventory.hotbarOffset) == null) {
+			if(inventory.getItem(i + inventory.hotbarOffset) == null) {
 				emptyHotbarSlot = i + inventory.hotbarOffset;
 				slot = i + inventory.hotbarOffset;
 				break;
@@ -1462,7 +1505,7 @@ public abstract class EntityPlayer extends EntityLiving
 		int itemSlot = -1;
 		int stackSize = -1;
 		for(int i=9; i < 36; i++) {
-			ItemStack stack = inventory.getStackInSlot(i);
+			ItemStack stack = inventory.getItem(i);
 			if(stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata()) {
 				if(stackSize == -1 || stack.stackSize < stackSize) {
 					itemSlot = i;
@@ -1474,8 +1517,8 @@ public abstract class EntityPlayer extends EntityLiving
 		if(itemSlot == -1) {
 			if(getGamemode() == Gamemode.creative) {
 				int emptySlot = -1;
-				for(int i=0; i < inventory.getSizeInventory(); i++) {
-					if(inventory.getStackInSlot(i) == null) {
+				for(int i = 0; i < inventory.getContainerSize(); i++) {
+					if(inventory.getItem(i) == null) {
 						emptySlot = i;
 						break;
 					}
@@ -1486,7 +1529,7 @@ public abstract class EntityPlayer extends EntityLiving
 				if(emptySlot != -1) {
 					swapItems(emptySlot, createItemInsertSlot);
 				}
-				inventory.setInventorySlotContents(createItemInsertSlot, selectItem);
+				inventory.setItem(createItemInsertSlot, selectItem);
 				setCurrentItem(createItemInsertSlot);
 			}
 			
@@ -1502,28 +1545,28 @@ public abstract class EntityPlayer extends EntityLiving
     }
     
     public void swapItems(int slot1, int slot2) {
-        ItemStack stack1 = inventory.getStackInSlot(slot1);
-        ItemStack stack2 = inventory.getStackInSlot(slot2);
+        ItemStack stack1 = inventory.getItem(slot1);
+        ItemStack stack2 = inventory.getItem(slot2);
 
-        inventory.setInventorySlotContents(slot2, stack1);
-        inventory.setInventorySlotContents(slot1, stack2);
+        inventory.setItem(slot2, stack1);
+        inventory.setItem(slot1, stack2);
     }
     public Item getNextArrow(){
         Item nextArrow = null;
         ItemStack quiverSlot = inventory.armorItemInSlot(2);
-        if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiver.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
-            nextArrow = Item.ammoArrow;
+        if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
+            nextArrow = Items.AMMO_ARROW;
         }
-        else if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiverGold.id){
-            nextArrow = Item.ammoArrowPurple;
+        else if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER_GOLD.id){
+            nextArrow = Items.AMMO_ARROW_PURPLE;
         }
-        else if (hasItem(Item.ammoArrowGold))
+        else if (hasItem(Items.AMMO_ARROW_GOLD))
         {
-            nextArrow = Item.ammoArrowGold;
+            nextArrow = Items.AMMO_ARROW_GOLD;
         }
-        else if(hasItem(Item.ammoArrow))
+        else if(hasItem(Items.AMMO_ARROW))
         {
-            nextArrow = Item.ammoArrow;
+            nextArrow = Items.AMMO_ARROW;
         }
         return nextArrow;
     }
@@ -1536,52 +1579,10 @@ public abstract class EntityPlayer extends EntityLiving
         }
         return false;
     }
-
-    public InventoryPlayer inventory;
-    public Container inventorySlots;
-    public Container craftingInventory;
-    public Gamemode gamemode = Gamemode.survival;
-    public byte field_9371_f;
-    public int score;
-    public List<String> messageHistory = new ArrayList<>();
-    public float cameraVelocityOld;
-    public float cameraVelocity;
-    public boolean isSwinging;
-    public int swingProgressInt;
-    public String username;
-    public int dimension;
-    public double xdO;
-    public double ydO;
-    public double zd0;
-    protected boolean sleeping;
-    public ChunkCoordinates bedChunkCoordinates;
-    private int sleepTimer;
-    public float field_22063_x;
-    public float field_22062_y;
-    public float field_22061_z;
-    private ChunkCoordinates playerSpawnCoordinate;
-    private ChunkCoordinates lastDeathCoordinate;
-    private ChunkCoordinates startMinecartRidingCoordinate;
-    public int timeUntilPortal;
-    protected boolean inPortal;
-    public int portalID;
-    public float timeInPortal;
-    public float prevTimeInPortal;
-    private final int damageRemainder;
-    public EntityBobber bobberEntity;
-    public volatile String skinURL;
-    public volatile String capeURL;
-    public boolean slimModel = false;
-
-    protected float baseSpeed = 0.1f;
-    protected float baseFlySpeed = 0.02f;
-    protected boolean isDwarf = false;
-    public int lastRenderTick = 0;
-    public float wobbleTimer = 0;
-    public static class SortByUsername implements Comparator<EntityPlayer> {
+    public static class SortByUsername implements Comparator<Player> {
 
         @Override
-        public int compare(EntityPlayer o1, EntityPlayer o2) {
+        public int compare(Player o1, Player o2) {
             return o1.username.compareTo(o2.username);
         }
     }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityArrow.java b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
similarity index 80%
rename from src/main/java/net/minecraft/core/entity/projectile/EntityArrow.java
rename to src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
index d8763e36a..dba79c5c7 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityArrow.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
@@ -1,26 +1,29 @@
 package net.minecraft.core.entity.projectile;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.HitResult;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, EntityPlayer, EntityLiving, MathHelper, 
+//            Entity, Player, Mob, MathHelper,
 //            World, Block, Vec3D, AxisAlignedBB, 
 //            MovingObjectPosition, NBTTagCompound, ItemStack, Item, 
 //            InventoryPlayer
 
-public class EntityArrow extends EntityProjectile
+public class ArrowProjectile extends Projectile
 {
+    public static final int TYPE_NORMAL = 0;
+    public static final int TYPE_PURPLE = 1;
+    public static final int TYPE_GOLDEN = 2;
     protected int xTile = -1;
     protected int yTile = -1;
     protected int zTile = -1;
@@ -28,7 +31,7 @@ public class EntityArrow extends EntityProjectile
     public int shake = 0;
     protected int inData = 0;
     protected int arrowType;
-    protected ItemStack stack = new ItemStack(Item.ammoArrow);
+    protected ItemStack stack = new ItemStack(Items.AMMO_ARROW);
     
     /*
      * I have reverted these to not be synced in multiplayer,
@@ -39,23 +42,23 @@ public class EntityArrow extends EntityProjectile
     protected boolean inGround = false;
     protected boolean doesArrowBelongToPlayer = false;
 
-	public EntityArrow(World world) {
-		this(world, 0);
+	public ArrowProjectile(World world) {
+		this(world, TYPE_NORMAL);
 	}
 	
-    public EntityArrow(World world, int arrowType)
+    public ArrowProjectile(World world, int arrowType)
     {
         super(world);
         this.arrowType = arrowType;
     }
 
-    public EntityArrow(World world, double d, double d1, double d2, int arrowType)
+    public ArrowProjectile(World world, double d, double d1, double d2, int arrowType)
     {
         super(world, d, d1, d2);
         this.arrowType = arrowType;
     }
 
-    public EntityArrow(World world, EntityLiving entityliving, boolean doesArrowBelongToPlayer, int arrowType)
+    public ArrowProjectile(World world, Mob entityliving, boolean doesArrowBelongToPlayer, int arrowType)
     {
         super(world, entityliving);
         setDoesArrowBelongToPlayer(doesArrowBelongToPlayer);
@@ -63,11 +66,10 @@ public class EntityArrow extends EntityProjectile
     }
 
     @Override
-	protected void init()
+	protected void initProjectile()
     {
-        super.init();
+        super.initProjectile();
         damage = 5;
-
     }
     
     public void setDoesArrowBelongToPlayer(boolean flag) {
@@ -94,7 +96,7 @@ public class EntityArrow extends EntityProjectile
         this.zd = zd;
         if(xRotO == 0.0F && yRotO == 0.0F)
         {
-            float f = MathHelper.sqrt_double(xd * xd + zd * zd);
+            float f = MathHelper.sqrt(xd * xd + zd * zd);
             yRot = (float) ((Math.atan2(xd, zd) * 180D) / Math.PI);
             xRot = (float) ((Math.atan2(yd, f) * 180D) / Math.PI);
             xRotO = xRot;
@@ -113,7 +115,7 @@ public class EntityArrow extends EntityProjectile
         }
         if(xRotO == 0.0F && yRotO == 0.0F)
         {
-            float f = MathHelper.sqrt_double(xd * xd + zd * zd);
+            float f = MathHelper.sqrt(xd * xd + zd * zd);
             yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
             xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
         }
@@ -122,7 +124,7 @@ public class EntityArrow extends EntityProjectile
         {
             block.setBlockBoundsBasedOnState(world, xTile, yTile, zTile);
             AABB axisalignedbb = block.getCollisionBoundingBoxFromPool(world, xTile, yTile, zTile);
-            if(axisalignedbb != null && axisalignedbb.isVecInside(Vec3d.createVector(x, y, z)))
+            if(axisalignedbb != null && axisalignedbb.contains(Vec3.getTempVec3(x, y, z)))
             {
                 setGrounded(true);
             }
@@ -148,7 +150,7 @@ public class EntityArrow extends EntityProjectile
             }
             return;
         }
-        else if(this instanceof EntityArrowGolden)
+        else if(this instanceof ArrowProjectileGolden)
         {
             world.spawnParticle("arrowtrail", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
             world.spawnParticle("arrowtrail", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
@@ -156,8 +158,8 @@ public class EntityArrow extends EntityProjectile
         super.tick();
     }
     public HitResult getHitResult(){
-        Vec3d oldPosition = Vec3d.createVector(x, y, z);
-        Vec3d newPosition = Vec3d.createVector(x + xd, y + yd, z + zd);
+        Vec3 oldPosition = Vec3.getTempVec3(x, y, z);
+        Vec3 newPosition = Vec3.getTempVec3(x + xd, y + yd, z + zd);
         return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition, false, true);
     }
     public void onHit(HitResult hitResult){
@@ -170,11 +172,11 @@ public class EntityArrow extends EntityProjectile
                 if(!world.isClientSide) {
                 	world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
                 }
-                if(!(this instanceof EntityArrowGolden))
+                if(!(this instanceof ArrowProjectileGolden))
                 {
                     remove();
                 }
-            } else if(!(this instanceof EntityArrowGolden))
+            } else if(!(this instanceof ArrowProjectileGolden))
             {
                 xd *= -0.1D;
                 yd *= -0.1D;
@@ -190,10 +192,10 @@ public class EntityArrow extends EntityProjectile
             zTile = hitResult.z;
             inTile = world.getBlockId(xTile, yTile, zTile);
             inData = world.getBlockMetadata(xTile, yTile, zTile);
-            xd = (float)(hitResult.location.xCoord - x);
-            yd = (float)(hitResult.location.yCoord - y);
-            zd = (float)(hitResult.location.zCoord - z);
-            float f1 = MathHelper.sqrt_double(xd * xd + yd * yd + zd * zd);
+            xd = (float)(hitResult.location.x - x);
+            yd = (float)(hitResult.location.y - y);
+            zd = (float)(hitResult.location.z - z);
+            float f1 = MathHelper.sqrt(xd * xd + yd * yd + zd * zd);
             x -= (xd / (double)f1) * 0.05D;
             y -= (yd / (double)f1) * 0.05D;
             z -= (zd / (double)f1) * 0.05D;
@@ -212,7 +214,7 @@ public class EntityArrow extends EntityProjectile
             world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
             for(int j = 0; j < 4; j++)
             {
-                world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, Item.ammoArrow.id);
+                world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, Items.AMMO_ARROW.id);
             }
             remove();
             return;
@@ -255,7 +257,7 @@ public class EntityArrow extends EntityProjectile
     }
 
     @Override
-	public void playerTouch(EntityPlayer player)
+	public void playerTouch(Player player)
     {
         if(world.isClientSide)
         {
@@ -266,7 +268,7 @@ public class EntityArrow extends EntityProjectile
         	player.inventory.insertItem(stack, true);
         	if(stack.stackSize <= 0) {
                 world.playSoundAtEntity(player, this, "random.pop", 0.2F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 2.0F);
-                player.onItemPickup(this, stack.itemID);
+                player.onItemPickup(this, stack);
                 remove();
         	}
         }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectileGolden.java b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectileGolden.java
new file mode 100644
index 000000000..b22d2d99a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectileGolden.java
@@ -0,0 +1,56 @@
+package net.minecraft.core.entity.projectile;
+
+// Referenced classes of package net.minecraft.src:
+//            Entity, Player, Mob, MathHelper,
+//            World, Block, Vec3D, AxisAlignedBB, 
+//            MovingObjectPosition, NBTTagCompound, ItemStack, Item, 
+//            InventoryPlayer
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class ArrowProjectileGolden extends ArrowProjectile
+{
+
+    public ArrowProjectileGolden(World world)
+    {
+        super(world, TYPE_GOLDEN);
+        this.noPhysics = true;
+        stack = new ItemStack(Items.AMMO_ARROW_GOLD);
+    }
+
+    public ArrowProjectileGolden(World world, double x, double y, double z)
+    {
+        super(world, x, y, z, TYPE_GOLDEN);
+        this.noPhysics = true;
+        stack = new ItemStack(Items.AMMO_ARROW_GOLD);
+    }
+
+    public ArrowProjectileGolden(World world, Mob owner, boolean doesArrowBelongToPlayer)
+    {
+        super(world, owner, doesArrowBelongToPlayer, TYPE_GOLDEN);
+        this.noPhysics = true;
+        stack = new ItemStack(Items.AMMO_ARROW_GOLD);
+    }
+
+    @Override
+	protected void initProjectile()
+    {
+        super.initProjectile();
+        defaultGravity = 0.02F;
+        defaultProjectileSpeed = 1.0F;
+        damage = 2;
+    }
+
+    @Override
+	public void playerTouch(Player player)
+    {
+        if (arrowBelongsToPlayer()){
+            super.playerTouch(player);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityArrowPurple.java b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectilePurple.java
similarity index 55%
rename from src/main/java/net/minecraft/core/entity/projectile/EntityArrowPurple.java
rename to src/main/java/net/minecraft/core/entity/projectile/ArrowProjectilePurple.java
index c11334787..f53610c9d 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityArrowPurple.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectilePurple.java
@@ -1,37 +1,38 @@
 package net.minecraft.core.entity.projectile;
 
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, EntityPlayer, EntityLiving, MathHelper, 
+//            Entity, Player, Mob, MathHelper,
 //            World, Block, Vec3D, AxisAlignedBB, 
 //            MovingObjectPosition, NBTTagCompound, ItemStack, Item, 
 //            InventoryPlayer
 
-public class EntityArrowPurple extends EntityArrow
+public class ArrowProjectilePurple extends ArrowProjectile
 {
 
-    public EntityArrowPurple(World world)
+    public ArrowProjectilePurple(World world)
     {
-        super(world, 1);
+        super(world, TYPE_PURPLE);
     }
 
-    public EntityArrowPurple(World world, double d, double d1, double d2)
+    public ArrowProjectilePurple(World world, double x, double y, double z)
     {
-        super(world, d, d1, d2, 1);
+        super(world, x, y, z, TYPE_PURPLE);
     }
 
-    public EntityArrowPurple(World world, EntityLiving entityliving, boolean doesArrowBelongToPlayer)
+    public ArrowProjectilePurple(World world, Mob owner, boolean doesArrowBelongToPlayer)
     {
-        super(world, entityliving, doesArrowBelongToPlayer, 1);
+        super(world, owner, doesArrowBelongToPlayer, TYPE_PURPLE);
     }
 
     @Override
-	protected void init()
+	protected void initProjectile()
     {
-        super.init();
+        super.initProjectile();
         defaultGravity = 0.03F;
         defaultProjectileSpeed = 0.99F;
         damage = 2;
@@ -42,7 +43,7 @@ public class EntityArrowPurple extends EntityArrow
         world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
         for(int j = 0; j < 4; j++)
         {
-            world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, Item.ammoArrowPurple.id);
+            world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, Items.AMMO_ARROW_PURPLE.id);
         }
         remove();
     }
